/**********************************************************
    File: main_frame.cpp
    Author: Carlos Moreno
    
    Description:
        Implementation for the main frame class in dialogs 
        demo.
 **********************************************************/

#include "main_frame.h"
#include "pwd_box.h"


BEGIN_EVENT_TABLE (MainFrame, wxFrame)
    EVT_MENU (ID_login, MainFrame::OnLogin)
    EVT_MENU (ID_exit, MainFrame::OnExit)
END_EVENT_TABLE ()

MainFrame::MainFrame (const wxString & title,
                      const wxPoint & position,
                      const wxSize & size)
    : wxFrame (NULL, -1, title, position, size)
{
    wxMenuBar * menuBar = new wxMenuBar;    // main menu bar

    wxMenu * menuFile = new wxMenu;         // menu items and submenus

    menuFile->Append (ID_login, "Login");
    menuFile->AppendSeparator();
    menuFile->Append (ID_exit, "E&xit");

    menuBar->Append (menuFile, "&File");
       	
    SetMenuBar (menuBar);
}

void MainFrame::OnLogin (wxCommandEvent &)
{
    PasswordDlg dlg (this);
    dlg.CentreOnParent();

    wxString msg;

    switch (dlg.ShowModal())
    {
        case wxID_OK:
            msg << "Login data submitted.  Name: " << dlg.get_name() 
                << ", Password: " << dlg.get_password();
            wxMessageBox (msg, "Dialogs Sample", 
                          wxOK, this);
            break;
    
        case wxID_CANCEL:
            wxMessageBox ("Login Cancelled", "Dialogs Sample",
                          wxOK | wxICON_EXCLAMATION, this);
            break;
    }
}

void MainFrame::OnExit (wxCommandEvent &)
{
    Close (true);
}
